#include <err.h>
#include <stdio.h>

#include <abac.h>

int main(int argc, char **argv) {
    int i, success;
    abac_credential_t *cred;

    if (argc < 2)
        errx(1, "Usage: %s <keystore>", argv[0]);

    libabac_init();

    abac_context_t *ctx = abac_context_new();
    abac_context_load_directory(ctx, argv[1]);

    abac_credential_t **credentials = abac_context_query(ctx,
        "06df985dc065fc69b508f6afa8dd127cd29ccc62.fed_create",
        "ef3584d91703acc4d9cb0f1f0950a31fc89e0b4c",
        &success
    );

    if (success)
        puts("success");

    if (credentials != NULL)
        for (i = 0; credentials[i] != NULL; ++i) {
            cred = credentials[i];
            printf("credential %s <- %s\n",
                    abac_role_string(abac_credential_head(cred)),
                    abac_role_string(abac_credential_tail(cred))
                  );
        }

    abac_context_credentials_free(credentials);

    abac_context_free(ctx);

    libabac_deinit();

    return 0;
}
