#include <err.h>
#include <stdio.h>
#include <vector>

#include <abac.hh>

using namespace ABAC;
using std::vector;

int main(int argc, char **argv) {
    int i;
    abac_credential_t *cred;

    if (argc < 2)
        errx(1, "Usage: %s <keystore>", argv[0]);

    libabac_init();

    Context ctx;
    ctx.load_directory(argv[1]);

    bool success;
    vector<Credential> credentials = ctx.query(
        "06df985dc065fc69b508f6afa8dd127cd29ccc62.fed_create",
        "ef3584d91703acc4d9cb0f1f0950a31fc89e0b4c",
        success
    );

    if (success)
        puts("success");
    for (vector<Credential>::iterator i = credentials.begin(); i != credentials.end(); ++i) {
        printf("credential %s <- %s\n",
            i->head().string(),
            i->tail().string()
        );
    }

    libabac_deinit();

    return 0;
}
